AttributeType
Date: 2016-06-25

org.osgi.service.metatype.annotations

## Enum AttributeType

- java.lang.Object
- - java.lang.Enum<AttributeType>
  - - org.osgi.service.metatype.annotations.AttributeType

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<AttributeType>

      public enum AttributeType
      extends java.lang.Enum<AttributeType>

  Attribute types for the `AttributeDefinition` annotation.
  See Also:
    `AttributeDefinition.type()`

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `BOOLEAN` The `Boolean` type.
    `BYTE` The `Byte` type.
    `CHARACTER` The `Character` type.
    `DOUBLE` The `Double` type.
    `FLOAT` The `Float` type.
    `INTEGER` The `Integer` type.
    `LONG` The `Long` type.
    `PASSWORD` The `Password` type.
    `SHORT` The `Short` type.
    `STRING` The `String` type.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `toString()`
    `static AttributeType` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static AttributeType[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### STRING

          public static final AttributeType STRING

      The `String` type.

      Attributes of this type should be stored as `String`, `List<String>` or `String[]` objects, depending on the `cardinality` value.

    - #### LONG

          public static final AttributeType LONG

      The `Long` type.

      Attributes of this type should be stored as `Long`, `List<Long>` or `long[]` objects, depending on the `AttributeDefinition#cardinality() cardinality` value.

    - #### INTEGER

          public static final AttributeType INTEGER

      The `Integer` type.

      Attributes of this type should be stored as `Integer`, `List<Integer>` or `int[]` objects, depending on the `AttributeDefinition#cardinality() cardinality` value.

    - #### SHORT

          public static final AttributeType SHORT

      The `Short` type.

      Attributes of this type should be stored as `Short`, `List<Short>` or `short[]` objects, depending on the `AttributeDefinition#cardinality() cardinality` value.

    - #### CHARACTER

          public static final AttributeType CHARACTER

      The `Character` type.

      Attributes of this type should be stored as `Character`, `List<Character>` or `char[]` objects, depending on the `AttributeDefinition#cardinality() cardinality` value.

    - #### BYTE

          public static final AttributeType BYTE

      The `Byte` type.

      Attributes of this type should be stored as `Byte`, `List<Byte>` or `byte[]` objects, depending on the `AttributeDefinition#cardinality() cardinality` value.

    - #### DOUBLE

          public static final AttributeType DOUBLE

      The `Double` type.

      Attributes of this type should be stored as `Double`, `List<Double>` or `double[]` objects, depending on the `AttributeDefinition#cardinality() cardinality` value.

    - #### FLOAT

          public static final AttributeType FLOAT

      The `Float` type.

      Attributes of this type should be stored as `Float`, `List<Float>` or `float[]` objects, depending on the `AttributeDefinition#cardinality() cardinality` value.

    - #### BOOLEAN

          public static final AttributeType BOOLEAN

      The `Boolean` type.

      Attributes of this type should be stored as `Boolean`, `List<Boolean>` or `boolean[]` objects depending on `AttributeDefinition#cardinality() cardinality`.

    - #### PASSWORD

          public static final AttributeType PASSWORD

      The `Password` type.

      Attributes of this type must be stored as `String`, `List<String>` or `String[]` objects depending on `cardinality`.

      A `Password` must be treated as a `String` but the type can be used to disguise the information when displayed to a user to prevent it from being seen.

  - ### Method Detail

    - #### values

          public static AttributeType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (AttributeType c : AttributeType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static AttributeType valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Enum<AttributeType>`